#include <sstream>
#include <iostream>
//
#include "TROOT.h"
#include "TFile.h"
#include "TTree.h"
#include "TSystem.h"
#include "TDataType.h"
#include "HepMC/GenEvent.h"
#include "HepMC/GenParticle.h"
#include "HepMC/GenVertex.h"
#include "HepMC/IO_GenEvent.h"

using namespace HepMC;
using namespace std;

int main(int argc,char** argv)
{
  // initialize ROOT
  gSystem->Load("libClassesDict");
  
  TFile* fo = new TFile("hepmc.root","RECREATE");
  
  // int Nevents = 1;
  
  HepMC::GenEvent* evt = new HepMC::GenEvent();
  HepMC::GenParticle* part = 
    new HepMC::GenParticle(HepMC::FourVector(10,20,30,40), 99);

  HepMC::GenVertex* vtx = new HepMC::GenVertex();

  vtx->add_particle_out(part);                                    
  evt->add_vertex( vtx );

  evt->print();
  HepMC::IO_GenEvent persist("/home/paktinat/tag_1_pythia8_events.hepmc", std::ios::in);


  TTree *T = new TTree("T","test");
  T->Branch("event",&evt,256000,0);
  
  int N = 0, Nmax = 9000;
  // double ptmin = 20.;
  // double etamax = 3.;
  // bool print = true;
  while ((evt = persist.read_next_event() )) {
    
     if (N%100==0) cout << "\nEvent #" << N+1 << ":" << endl;
    //cout << "\nEvent #" << N+1 << ":" << endl;

    if(N <5) {evt->print();gDebug=2;
      evt->print_version();
    }

    T->Fill();
    N++;
    if (N == Nmax) break;
    
  }
  T->Print();
  T->Write();
  delete fo;

}
